procedure itest48 (input, logfile)

string	input	=""	{prompt="List of input images"}
string	logfile	=""	{prompt="Text logfile (for error messages)"}
int	nimg	=0	{prompt="Number of images in input list"}
int	ncol	=INDEF	{prompt="Number of columns (1st image)"}
int	nrow	=INDEF	{prompt="Number of lines (1st image)"}
bool	hdrproc	=no	{prompt="Processing directed by header keywords?"}
bool	ok	=yes	{prompt="Does al input exist?"}

# @(#) subtask itest48            Author: R.A. Jansen -- January 17 1996
# @(#) 
# @(#) subtask called from 'ccd48proc' to check whether input image list
# @(#) and all images in the input list exist,  and that all images have
# @(#) same size.  That size is then passed to the main routine.
# @(#)
# @(#) Feb  6 1998 -- Replaced 'access' checks by call to 'chkimg'. RAJ.
# @(#) Jul 13 2000 -- Added support for image format other than OIF. RAJ
# @(#) Aug 11 2003 -- Added 'nimg', 'ncol', 'nrow' and 'logfile' parame-
# @(#)                ters and test that all images have same size. RAJ.
# @(#) Jul  6 2004 -- To better support header-directed processing, task
# @(#)                parameter 'hdrproc' was added as well as some con-
# @(#)                ditional opening messages. RAJ.

begin
	string	cfil, cimg, cval
	int	i, nl, nc, nr, nc1, nr1, ifrc
	bool	bok, first, bhdr

#	Initialize variables...
	cfil	= input
	bhdr	= no
	bok	= ok

#	(Re)initialize task parameters...
	input	= cfil
	nimg	= INDEF
	ncol	= INDEF
	nrow	= INDEF
	hdrproc = bhdr
	ok	= bok

#	Return when status on entry was not ok...
	if (!bok) { return }

#	Check whether the input file with image names exists...
	chkimg (cfil, "access", imtype="file", verbose+)
	if (!chkimg.ok) { ok = no ; return }
	cfil  = chkimg.impath//chkimg.imroot
	input = cfil

#	Count number of images in the input list...
	iwc (cfil)
	nl = iwc.nlines
	if ( nl == 0 ) {
	   sysinfo() ; gdate(utc=no)
	   if ( substr(ccd48proc.version,7,11) == "LOCAL") {
	      print ("\n## CCD48PROC["//substr(ccd48proc.version,14,28)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
	   } else {
	      print ("\n## CCD48PROC["//substr(ccd48proc.version,1,12)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
	   }
           print ("## ---------------------------------------------------------------------------", >> logfile)
	   print ("ERROR: \""//cfil//"\" is empty!", >> logfile)
	   print ("ERROR: \""//cfil//"\" is empty!")
	   nimg  = 0
	   ok    = no
	   return
	} else if ( nl != iwc.nwords ) {
	   sysinfo() ; gdate(utc=no)
	   if ( substr(ccd48proc.version,7,11) == "LOCAL") {
	      print ("\n## CCD48PROC["//substr(ccd48proc.version,14,28)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
	   } else {
	      print ("\n## CCD48PROC["//substr(ccd48proc.version,1,12)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
	   }
           print ("## ---------------------------------------------------------------------------", >> logfile)
	   print ("ERROR: \""//cfil//"\" may have more than one image per line, or", >> logfile)
	   print ("       leading and/or trailing blank lines!", >> logfile)
	   print ("ERROR: \""//cfil//"\" may have more than one image per line, or")
	   print ("       leading and/or trailing blank lines!")
	   ok    = no
	   return
	} else {
	   nimg  = nl
	}

#	Loop over all images and test whether they exist or not...
	first = yes
	for ( i = 1 ; i <= nl ; i = i + 1 ) {
	   rdlist (cfil, i)
	   if (!rdlist.ok) { ok = no ; return }
	   chkimg (rdlist.cline, "access", imtype="", verbose+)
	   if (!chkimg.ok) { ok = no ; return }
	   cimg = chkimg.impath//chkimg.imroot//chkimg.imtype
	   if ( chkimg.imrpstr != "" ) {
	      if (first) {
		sysinfo() ; gdate(utc=no)
		if ( substr(ccd48proc.version,7,11) == "LOCAL") {
		  print ("\n## CCD48PROC["//substr(ccd48proc.version,14,28)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
		} else {
		  print ("\n## CCD48PROC["//substr(ccd48proc.version,1,12)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
		}
		print ("## ---------------------------------------------------------------------------", >> logfile)
		first = no
	      }
	      print ("WARNING: \""//cimg//chkimg.imrpstr//"\" - Ignoring image section!", >> logfile)
	      print ("WARNING: \""//cimg//chkimg.imrpstr//"\" - Ignoring image section!")
	   }
	   if ( i == 1 ) {
	      hselect (cimg, "i_naxis1", "yes") | scan (nc1)
	      hselect (cimg, "i_naxis2", "yes") | scan (nr1)

	      # Check whether processing may be directed by header keywords
	      cval = "" ; hselect (cimg, "cc48proc", "yes") | scan (cval)
	      if ( cval == "PERFORM" ) { bhdr = yes }

	   } else {
	      hselect (cimg, "i_naxis1", "yes") | scan (nc)
	      hselect (cimg, "i_naxis2", "yes") | scan (nr)
	      if ( nc != nc1 || nr != nr1 ) {
		 if (first) {
		   sysinfo() ; gdate(utc=no)
		   if ( substr(ccd48proc.version,7,11) == "LOCAL") {
		     print ("\n## CCD48PROC["//substr(ccd48proc.version,14,28)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
		   } else {
		     print ("\n## CCD48PROC["//substr(ccd48proc.version,1,12)//"]:   "//sysinfo.username//"@"//sysinfo.host//"   "//gdate.tdate, >> logfile)
		   }
		   print ("## ---------------------------------------------------------------------------", >> logfile)
		   first = no
		 }
		 printf("ERROR: \""//cimg//"\" has size [%d,%d] instead of [%d,%d]!\n",
			nc, nr, nc1, nr1, >> logfile)
		 printf("ERROR: \""//cimg//"\" has size [%d,%d] instead of [%d,%d]!\n",
			nc, nr, nc1, nr1)
		 ok = no
		 return
	      }
	   }

	   ifrc = nint(100.*i/nl)
	   if ( (ifrc % 2 ) == 0 ) printf("\r %3d %1s done...\r", ifrc, "%")
	}
	printf("\r                                                      \r")

#	Update remaining task parameters...
	ncol	= nc1
	nrow	= nr1
	hdrproc = bhdr

end
